"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com

Visuse is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""
# -*- coding: utf-8 -*-
#!/usr/bin/python

import urllib2
import json
from classes import *
import config


class Flickr(Result, ImageResult):
	# http://www.flickr.com/services/api/misc.urls.html
	# Page		http://www.flickr.com/photos/{user-id}/{photo-id} - individual photo
	# Foto:		http://farm{farm-id}.static.flickr.com/{server-id}/{id}_{secret}.jpg
	def __init__(self, name, id, user, farm, server, secret):
		url = "http://www.flickr.com/photos/" + user + "/" + str(id)
		thumbnail = "http://farm" + str(farm) + ".static.flickr.com/" + \
			str(server) + "/" + str(id) + "_" + str(secret) + "_m.jpg"
		ImageResult.__init__(self, name, url, thumbnail)
			


class SearchFlickr(SearchModule):
	def __init__(self):
		SearchModule.__init__(self)

		
	def search(self, search_terms):
		nojsoncallback = '1'
		format = 'json'
		
		url = 'http://api.flickr.com/services/rest/?method=%s&api_key=%s&format=%s&nojsoncallback=%s&text=%s&per_page=%s&sor=%s' \
			% (config.flickr_method, config.flickr_api_key, format, nojsoncallback, search_terms, config.flickr_results_per_page, config.flickr_sort)
		
		file = urllib2.urlopen(url).read()
		
		#creamos un diccionario con los datos que nos interesan
		resultDictionary = json.loads(file)['photos']['photo']

		for i in resultDictionary:
			self.add(i)
		
		return self.resultList
	

	def add(self, entry):
		self.resultList.append(Flickr( \
			entry['title'], \
			entry['id'], \
			entry['owner'], \
			entry['farm'], \
			entry['server'], \
			entry['secret'], \
		))
		


#~ s = SearchFlickr()
#~ s.search("molina")
#~ print unicode(s).encode("iso-8859-2", "replace")
