"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com

Visuse is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""
# -*- coding: utf-8 -*-
#!/usr/bin/python

import gdata.youtube
import gdata.youtube.service
import json
from classes import Result, ImageResult, SearchModule
#from config import youtube_key, youtube_order
import config


class Youtube(Result, ImageResult):
    def __init__(self, name, url, thumbnail, summary, tags, view_count, rating, player_url):
        ImageResult.__init__(self, name, url, thumbnail)
        self.summary = summary
        self.tags = tags
        self.view_count = view_count
        self.rating = rating
        self.player_url = player_url
		
	
	
	
	
class SearchYoutube(SearchModule):
	def __init__(self):
		SearchModule.__init__(self)

	
	def search(self, search_terms):
		yt_service = gdata.youtube.service.YouTubeService()
		yt_service.developer_key = config.youtube_key
		
		query = gdata.youtube.service.YouTubeVideoQuery()
		query.vq = search_terms
		query.orderby = config.youtube_order
		query.racy = 'include'
		feed = yt_service.YouTubeQuery(query)
		
		for entry in feed.entry:
			self.add(entry)
		
		return self.resultList
	

	def add(self, entry):
		
		#~ thumbnailList = []
		#~ for thumb in entry.media.thumbnail:
			#~ thumbnail = ImageLink(thumb.url, thumb.width, thumb.height)
			#~ thumbnailList.append(thumbnail)
		try:
			media = entry.rating.average
		except AttributeError:
			media = 0
		
		self.resultList.append(Youtube( \
			entry.media.title.text, \
			entry.media.player.url, \
			entry.media.thumbnail[-1].url, \
			entry.media.description.text, \
			entry.media.keywords.text, \
			entry.statistics.view_count, \
			media, \
			entry.GetSwfUrl() \
		))
		


#~ sy = SearchYoutube()
#~ sy.search("big bang theory")
#~ print(sy)


